// InternetUpdate.cpp: implementation of the CInternetUpdate class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "InternetUpdate.h"
#include "Update.H"
#include "Update_i.c"

void CInternetUpdate::Download(WORD wVersion1, WORD wVersion2, WORD wVersion3, WORD wVersion4)
{
	CString strError;
	ICoUpdate *piUpdate = NULL;
	try
	{
		CString strError;
		HRESULT res = ::CoCreateInstance(CLSID_CoUpdate, NULL, CLSCTX_ALL, IID_ICoUpdate, (void**)&piUpdate);
		switch(res)
		{
		case S_OK:
			break;
		case REGDB_E_CLASSNOTREG:
			strError = "A specified class is not registered in the registration database. Also can indicate that the type of server you requested in the CLSCTX enumeration is not registered or the values for the server types in the registry are corrupt.";
			break;
		case CLASS_E_NOAGGREGATION:
			strError = "This class cannot be created as part of an aggregate.";
			break;
		default:
			strError.Format("Unknown error. HRESULT = 0x%x", res);
		}
		if(!strError.IsEmpty())
			throw new CException("FATAL ERROR: Create update component failed!\r\nRun\r\n\r\nregsvr32 IOUpdate.dll\r\n\r\nfor registering.\r\n" + strError);
		BSTR bstrURL = m_strURL.AllocSysString();
		CString strCaption(m_strMessageBoxCaption);
		BSTR bstrCaption = strCaption.AllocSysString();
		BSTR bstrTempFolder = m_strTempFolder.AllocSysString();
		BSTR bstrDefaultInstallDirectory = m_strDefaultInstallDirectory.AllocSysString();
		HRESULT hr = piUpdate->Update(bstrURL, bstrCaption, m_boPromptNewestVersion
			, wVersion1, wVersion2, wVersion3, wVersion4, bstrTempFolder, bstrDefaultInstallDirectory);
		::SysFreeString(bstrDefaultInstallDirectory);
		::SysFreeString(bstrTempFolder);
		::SysFreeString(bstrCaption);
		::SysFreeString(bstrURL);
		if(hr == S_FALSE)
		{
			CComBSTR bsError;
			piUpdate->get_Error(&bsError.m_str);
			CString strError = bsError.m_str;
			throw new CException(strError);
		}
	}
	catch(CException* e)
	{
		strError = e->GetErrorMessage();
		delete e;
		e = NULL;
	}
	if(piUpdate)
		piUpdate->Close();
	if(!strError.IsEmpty())
		throw new CException(strError);
}

void CInternetUpdate::DownloadAndInstall(LPCTSTR lpszFolder)
{
	CString strError;
	ICoUpdate *piUpdate = NULL;
	try
	{
		if (FAILED(::CoCreateInstance(CLSID_CoUpdate, NULL, CLSCTX_ALL, IID_ICoUpdate, (void**)&piUpdate)))
			throw new CException("FATAL ERROR: Create update component failed!\r\nRun\r\n\r\nregsvr32 IOUpdate.dll\r\n\r\nfor registering.\r\n" + strError);
		BSTR bstrURL = m_strURL.AllocSysString();
		CString strFolder = lpszFolder;
		BSTR bstrFolder = strFolder.AllocSysString();
		CString strCaption(m_strMessageBoxCaption);
		BSTR bstrCaption = strCaption.AllocSysString();
		BSTR bstrTempFolder = m_strTempFolder.AllocSysString();
		BSTR bstrDefaultInstallDirectory = m_strDefaultInstallDirectory.AllocSysString();
		HRESULT hr = piUpdate->DownloadAndInstall(bstrURL, bstrFolder, bstrCaption, bstrTempFolder
			, bstrDefaultInstallDirectory);
		::SysFreeString(bstrDefaultInstallDirectory);
		::SysFreeString(bstrTempFolder);
		::SysFreeString(bstrCaption);
		::SysFreeString(bstrFolder);
		::SysFreeString(bstrURL);
		if(hr == S_FALSE)
		{
			CComBSTR bsError;
			piUpdate->get_Error(&bsError.m_str);
			CString strError = bsError.m_str;
			throw new CException(strError);
		}
	}
	catch(CException* e)
	{
		strError = e->GetErrorMessage();
		delete e;
		e = NULL;
	}
	if(piUpdate)
	{
		piUpdate->Close();
	}
	if(!strError.IsEmpty())
		throw new CException(strError);
}
