// InternetUpdateEm.h : Declaration of the CInternetUpdateEm

#ifndef __InternetUpdateEm_H_
#define __InternetUpdateEm_H_

#include "InternetUpdate.h"

/////////////////////////////////////////////////////////////////////////////
// CInternetUpdateEm
// For updating or installing of an application or file in separate thread

class CInternetUpdateEm : public CInternetUpdate
{
public:
	//Constructor
	//See CInternetUpdate for details
	CInternetUpdateEm(LPCTSTR lpszMessageBoxCaption, LPCTSTR lpszURL, LPCTSTR lpszDefaultInstallDirectory
			, LPCTSTR lpszTempFolder)
		: CInternetUpdate(lpszMessageBoxCaption, lpszURL, lpszDefaultInstallDirectory, lpszTempFolder)
		, m_hThread(0)
	{
	}

	~CInternetUpdateEm()
	{
		if(m_hThread)
		{
			VERIFY(::CloseHandle(m_hThread));
			m_hThread = NULL;
		}
	}

	//See CInternetUpdate for details
	void DownloadAndInstall(LPCTSTR lpszFolder);

	//Updating to newest version or back to previous version
	//BOOL boPromptNewestVersion
	//		TRUE - informs user about he use newest version. No necessary to update.
	//			User can return to old version in this case yet.
	//		FALSE - Nothing does if newest version is used. This mode is useful to updating in
	//			separate thread during starting of the application. See using of the CInternetUpdateEm
	//			class for details.
	void GetLastVersion(BOOL boPromptNewestVersion)
	{
		m_boPromptNewestVersion = boPromptNewestVersion;
		DWORD dwThreadId;
		m_hThread = ::CreateThread(NULL,0,ThreadProc,(void*)this,0,&dwThreadId);
		ATLASSERT((unsigned long)m_hThread != -1);
	}

protected:

	virtual void Download(WORD wVersion1, WORD wVersion2, WORD wVersion3, WORD wVersion4);

private:
	HANDLE m_hThread;

	static DWORD WINAPI ThreadProc(LPVOID lpParameter)
	{
		HRESULT hRes = ::CoInitialize(NULL);
		ATLASSERT(SUCCEEDED(hRes));

		ATLASSERT(lpParameter);
		CInternetUpdate* pInternetUpdate = (CInternetUpdate*)lpParameter;

		///////////////////////////////////////////////////////////////////////////
		//You can use GetFileVersion(...) function for determining of actual version of a updated file.
		WORD wVersion1 = 0;
		WORD wVersion2 = 0;
		WORD wVersion3 = 0;
		WORD wVersion4 = 0;
		::GetFileVersion((LPTSTR)(LPCTSTR)::GetModuleFileName(), &wVersion1, &wVersion2, &wVersion3, &wVersion4);
		pInternetUpdate->Download(wVersion1, wVersion2, wVersion3, wVersion4);
		
//		pInternetUpdate->Download(1,1,1,109);

		::ExitThread(0);
		return 0;
	}
};

#endif //__InternetUpdateEm_H_
