// maindlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINDLG_H__DA779C91_A354_4879_B707_76D4D28BEE0E__INCLUDED_)
#define AFX_MAINDLG_H__DA779C91_A354_4879_B707_76D4D28BEE0E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "InternetUpdate.h"
#include "InternetUpdateEm.h"
#include <atlctrlx.h>

LPCTSTR g_lpszURL = "ftp://comber-adsl.demon.co.uk/Updates/";
//LPCTSTR g_lpszURL = "ftp://h17f186c/";

class CMainDlg : public CDialogImpl<CMainDlg>, public CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler
{
public:
	CMainDlg()
		: m_internetUpdate("Update Test", g_lpszURL + CString("UpdateTest"), ::GetModuleDirectory()
			, ::GetModuleDirectory() + "Update\\")
	{}

	enum { IDD = IDD_MAINDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		return IsDialogMessage(pMsg);
	}

	virtual BOOL OnIdle()
	{
		return FALSE;
	}

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_HANDLER(IDC_BTN_UPDATE, BN_CLICKED, OnClickedBtn_update)
		COMMAND_HANDLER(IDC_BTN_DOWNLOAD, BN_CLICKED, OnClickedBtn_download)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)
private:
	CInternetUpdateEm m_internetUpdate;

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// center the dialog on the screen
		CenterWindow();

		// set icons
		HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
		SetIcon(hIcon, TRUE);
		HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
		SetIcon(hIconSmall, FALSE);

		// register object for message filtering and idle updates
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		UIAddChildWindowContainer(m_hWnd);

		VERIFY(SetDlgItemText(IDC_EDIT_URL, g_lpszURL));
		VERIFY(SetDlgItemText(IDC_EDIT_UPDATE_FOLDER, "UpdateTest"));
		VERIFY(SetDlgItemText(IDC_EDIT_DOWNLOAD_FOLDER, "Em/MDAC"));

		//Test in the separate thread for newest version is available
		try
		{
			m_internetUpdate.GetLastVersion(FALSE);
		}
		catch(CException* e)
		{
			::MessageBox(NULL, e->GetErrorMessage(), "Update test error", MB_ICONSTOP);
			delete e;
			e = NULL;
		}

		return TRUE;
	}

	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CAboutDlg dlg;
		dlg.DoModal();
		return 0;
	}

	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		// TODO: Add validation code 
		CloseDialog(wID);
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CloseDialog(wID);
		return 0;
	}

	void CloseDialog(int nVal)
	{
		DestroyWindow();
		::PostQuitMessage(nVal);
	}
	LRESULT OnClickedBtn_update(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CWaitCursor w;
		const int nMaxCount = 1024;

		//URL
		CString strURL;
		VERIFY(GetDlgItemText(IDC_EDIT_URL, strURL.GetBuffer(nMaxCount), nMaxCount));
		strURL.ReleaseBuffer();
		strURL = ::AddSlashToEndString(strURL);

		//Folder
		CString strFolder;
		VERIFY(GetDlgItemText(IDC_EDIT_UPDATE_FOLDER, strFolder.GetBuffer(nMaxCount), nMaxCount));
		strFolder.ReleaseBuffer();

		CInternetUpdate internetUpdate("Update Test", strURL + strFolder, ::GetModuleDirectory()
			, ::GetModuleDirectory() + "Update\\", TRUE);

		try
		{
			///////////////////////////////////////////////////////////////////////////
			//You can use GetFileVersion(...) function for determining of actual version of a updated file.
					
			WORD wVersion1 = 0;
			WORD wVersion2 = 0;
			WORD wVersion3 = 0;
			WORD wVersion4 = 0;
			::GetFileVersion((LPTSTR)(LPCTSTR)::GetModuleFileName(), &wVersion1, &wVersion2, &wVersion3, &wVersion4);
			internetUpdate.Download(wVersion1, wVersion2, wVersion3, wVersion4);
			
//			internetUpdate.Download(1,1,1,109);
		}
		catch(CException* e)
		{
			::MessageBox(NULL, e->GetErrorMessage(), "Update test error", MB_ICONSTOP);
			delete e;
			e = NULL;
		}

		return 0;
	}
	LRESULT OnClickedBtn_download(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CWaitCursor w;
		const int nMaxCount = 1024;

		//URL
		CString strURL;
		VERIFY(GetDlgItemText(IDC_EDIT_URL, strURL.GetBuffer(nMaxCount), nMaxCount));
		strURL.ReleaseBuffer();
		strURL = ::AddSlashToEndString(strURL);

		//Folder
		CString strFolder;
		VERIFY(GetDlgItemText(IDC_EDIT_DOWNLOAD_FOLDER, strFolder.GetBuffer(nMaxCount), nMaxCount));
		strFolder.ReleaseBuffer();

		CInternetUpdate internetUpdate("Update Test", strURL, ::GetModuleDirectory()
			, ::GetModuleDirectory() + "Update\\");
		try
		{
			internetUpdate.DownloadAndInstall(strFolder);
		}
		catch(CException* e)
		{
			::MessageBox(NULL, e->GetErrorMessage(), "Update test error", MB_ICONSTOP);
			delete e;
			e = NULL;
		}

		return 0;
	}
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__DA779C91_A354_4879_B707_76D4D28BEE0E__INCLUDED_)
