// UpdateTest.cpp : main source file for UpdateTest.exe
//

#include "stdafx.h"

#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>
#include <atlctrlw.h>

#include "resource.h"

#include "aboutdlg.h"
#include "maindlg.h"

CAppModule _Module;

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	CMainDlg dlgMain;

	if(dlgMain.Create(NULL) == NULL)
	{
		ATLTRACE(_T("Main dialog creation failed!\n"));
		return 0;
	}

	dlgMain.ShowWindow(nCmdShow);

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_COOL_CLASSES | ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}

CString GetDir(LPCTSTR lpszPath)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	::_splitpath(lpszPath, drive, dir, fname, ext );
	CString strDir;
	::_makepath(strDir.GetBuffer(_MAX_PATH), drive, dir, "", "");
	strDir.ReleaseBuffer();
	return strDir;
}

CString AddSlashToEndString(CString str)
{
	if(!str.IsEmpty() && str[str.GetLength() -1] != '/')
		str += '/';
	return str;
}

CString GetModuleFileName()
{
	TCHAR szModuleFileName[1024];
	VERIFY(::GetModuleFileName(_Module.GetModuleInstance(), szModuleFileName, 1024));
	CString strModuleFileName = szModuleFileName;
	return strModuleFileName;
}

CString GetModuleDirectory()
{
	return ::GetDir(::GetModuleFileName());
}

BOOL GetFileVersion(LPTSTR lpszFileName, WORD* pwVersion1, WORD* pwVersion2, WORD* pwVersion3, WORD* pwVersion4)
{
	DWORD   dwVerHnd=0;        // An 'ignored' parameter, always '0'
	DWORD dwVerInfoSize = ::GetFileVersionInfoSize(lpszFileName, &dwVerHnd);
	if(dwVerInfoSize == 0)
	{
		ATLASSERT(FALSE);
		return FALSE;
	}
	LPSTR   lpstrVffInfo;
	HANDLE  hMem;
	hMem = ::GlobalAlloc(GMEM_MOVEABLE, dwVerInfoSize);
	lpstrVffInfo  = (LPSTR)::GlobalLock(hMem);
	VERIFY(::GetFileVersionInfo(lpszFileName, dwVerHnd, dwVerInfoSize, lpstrVffInfo));
	UINT    uVersionLen = 1023;
	VS_FIXEDFILEINFO* pfixedFileInfo;
	VERIFY(::VerQueryValue((LPVOID)lpstrVffInfo,
		 TEXT("\\"),
		 (LPVOID*)&pfixedFileInfo,
		 (UINT *)&uVersionLen));
	*pwVersion1 = HIWORD(pfixedFileInfo->dwFileVersionMS);
	*pwVersion2 = LOWORD(pfixedFileInfo->dwFileVersionMS);
	*pwVersion3 = HIWORD(pfixedFileInfo->dwFileVersionLS);
	*pwVersion4 = LOWORD(pfixedFileInfo->dwFileVersionLS);
	GlobalUnlock(hMem);
	GlobalFree(hMem);
	return TRUE;
}
